Attribute VB_Name = "modDeclaFunc"
Option Explicit

Public dose, rohr, kugel, box, flaeche, iniDat As Boolean
Public inpFreq, inpSa, inpSb, inpSc, inpSDm, inpDDm As Double
Public inpZDm, inpZLg, inpRDm, inpRLg, inpKDm, inpFl As Double
Public fl, z, cap, c, ind, z1, m As Double
Public I, l, lg, n, ergebnis, DateiZaehler As Integer
Public DE, US, FR, it, GR, cz, es As String
Public FirstPath, ThePath, entry, lblFormCaption, lblSplashCaption, selLang, selFile As String
Public fName, lang, shortLanguage, fileLanguage, inpCopyright As String
Public varDElabel2, varUSlabel2, varInpWert As Variant
Public lCount As Long
Public Const PI = 3.14159265358979
Public varUSarray(12)
Public arrDatei

' Frames Position
Public Const conLeft = 105
Public Const conTop = 315
Public Const conWith = 1700
Public Const conHeight = 645
Public Const conDiff = 735


'API-Funktionen deklarieren
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" _
    (ByVal lpApplicationname As String, _
    ByVal lpKeyName As Any, _
    ByVal lsString As Any, _
    ByVal lplFilename As String) As Long

Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
    (ByVal lpApplicationname As String, _
    ByVal lpKeyName As String, _
    ByVal lpDefault As String, _
    ByVal lpReturnedString As String, _
    ByVal nSize As Long, _
    ByVal lpFileName As String) As Long

Public Function AppPathGet() As String
Dim zw As String
    zw = App.Path
    If Right(zw, 1) <> "\" Then
        zw = zw & "\"
    End If
    AppPathGet = zw
End Function

'Funktionen/Aufrufe
' Laden
Public Function GetINISetting(ByVal Filename As String, _
    ByVal Key As String, _
    ByVal Setting As String, _
    ByVal Default As String) As Variant
    Dim Temp As String * 1024
        Call GetPrivateProfileString(Key, Setting, Default, Temp, Len(Temp), Filename)
        GetINISetting = Mid(Temp, 1, InStr(1, Temp, Chr(0)) - 1)
End Function

' Speichern
Public Function SaveINISetting(ByVal Filename As String, _
    ByVal Key As String, _
    ByVal Setting As String, _
    ByVal Value As String)
        Call WritePrivateProfileString(Key, Setting, Value, Filename)
End Function

' Dateiauflistung (*.ini/*.lng)
Public Function DateiLister(DateiZaehler As Integer) As Integer
On Local Error GoTo DateiListerFehler
    frmHaupt.datListe.Path = AppPathGet
    For lg = 0 To frmHaupt.datListe.ListCount - 1
        fName = ThePath + frmHaupt.datListe.List(lg)
            For n = 1 To Len(fName)
                If Mid(fName, n, 1) = "." Then entry = Left(fName, (n - 1))
            Next
        frmHaupt.lstFoundFiles.AddItem entry
    Next lg
    Exit Function
    
DateiListerFehler:
    If Err = 7 Then                 ' Wenn Speicher voll,
        DateiLister = True          ' Fehlermeldung und Suche abgebrochen
        MsgBox "Listbox voll - Suche abgebrochen..."
        Exit Function               ' Achtung.. setzt Err auf 0
    Else                            ' andernfalls Fehlerausgabe und Ausstieg
        MsgBox Error
        End
    End If
End Function

' Dateisuche (in Verbindung mit DateiLister)
Public Sub searchFiles()
    FirstPath = AppPathGet
    ergebnis = DateiLister(DateiZaehler)
    frmHaupt.datListe.Path = FirstPath
End Sub

' Sprache ermitteln
Public Sub selectLanguage()
    For n = 0 To frmHaupt.lstFoundFiles.ListCount - 1
        'Eintrag selektiert?
        If frmHaupt.lstFoundFiles.Selected(n) Then
            selLang = frmHaupt.lstFoundFiles.List(n)
        End If
    Next
    If selLang = "" Then selLang = "DE"
    selFile = selLang + ".lng"
    fName = selFile
    lang = selLang
    changeLabel2
    changeLabelOut
    If iniDat = False Then writeINIFile
    iniDat = True
End Sub

' KAP-Initialisierungsdatei laden
Public Sub loadINIFile()
    shortLanguage = GetINISetting(AppPathGet & "KAP.ini", "language", "Short", "")
    fileLanguage = GetINISetting(AppPathGet & "KAP.ini", "language", "File", "")
End Sub

' KAP-Initialisierungsdatei schreiben
Public Sub writeINIFile()
    SaveINISetting AppPathGet & "KAP.ini", "language", "Short", selLang
    SaveINISetting AppPathGet & "KAP.ini", "language", "File", selFile
End Sub

' Sprachdatei laden
Public Sub loadLanguage()
' Form
    If shortLanguage <> "DE" Then
        frmHaupt.lblSS(5).Visible = True
        frmHaupt.lblSS(6).Visible = True
    End If
    inpCopyright = GetINISetting(AppPathGet & fName, "Form", "LBL_FORM", "")
        If Right(inpCopyright, 9) = "  DL7AHW" Then
            frmHaupt.Caption = inpCopyright
        Else
            frmHaupt.Caption = inpCopyright & "  DL7AHW"
        End If
    frmHaupt.Label1.Caption = GetINISetting(AppPathGet & fName, "Form", "LBL_CAPACITIES", "")
    frmHaupt.Label3(0).Caption = GetINISetting(AppPathGet & fName, "Form", "LBL_CAN_RADIATOR", "")
    frmHaupt.Label3(1).Caption = GetINISetting(AppPathGet & fName, "Form", "LBL_TUBE_RADIATOR", "")
    frmHaupt.Label3(2).Caption = GetINISetting(AppPathGet & fName, "Form", "LBL_BALL_RADIATOR", "")
    frmHaupt.Label3(3).Caption = GetINISetting(AppPathGet & fName, "Form", "LBL_BOX_RADIATOR", "")
    frmHaupt.Label3(4).Caption = GetINISetting(AppPathGet & fName, "Form", "LBL_AREA_RADIATOR", "")
' Buttons
    frmHaupt.cmdRechne.Caption = GetINISetting(AppPathGet & fName, "Buttons", "LBL_BUT_CALC", "")
' Menu
    frmHaupt.MNU_KAP_0.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_PROGRAM", "")
    frmHaupt.MNU_KAP_1.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_QUIT", "")
    frmHaupt.MNU_KAP_2.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_ANTENNA", "")
    frmHaupt.MNU_KAP_3.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_CAPACITIES", "")
    frmHaupt.MNU_KAP_4.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_KAP_RADIATOR", "")
    frmHaupt.MNU_KAP_5.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_CAN", "")
    frmHaupt.MNU_KAP_6.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_TUBE", "")
    frmHaupt.MNU_KAP_7.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_BALL", "")
    frmHaupt.MNU_KAP_8.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_BOX", "")
    frmHaupt.MNU_KAP_9.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_AREA", "")
    frmHaupt.MNU_KAP_10.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_HELP", "")
    frmHaupt.MNU_KAP_11.Caption = GetINISetting(AppPathGet & fName, "Menu", "MNU_ABOUT", "")
' SplashScreen
    frmHaupt.lblSS(0).Caption = GetINISetting(AppPathGet & fName, "SplashScreen", "LBL_SPLASH_0", "")
    frmHaupt.lblSS(1).Caption = GetINISetting(AppPathGet & fName, "SplashScreen", "LBL_SPLASH_1", "")
    frmHaupt.lblSS(2).Caption = GetINISetting(AppPathGet & fName, "SplashScreen", "LBL_SPLASH_2", "")
    frmHaupt.lblSS(6).Caption = GetINISetting(AppPathGet & fName, "SplashScreen", "LBL_SPLASH_3", "")
' Frames
    frmHaupt.Frame1(0).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_00", "")
    frmHaupt.Frame1(1).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_01", "")
    frmHaupt.Frame1(2).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_02", "")
    frmHaupt.Frame1(3).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_03", "")
    frmHaupt.Frame1(4).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_04", "")
    frmHaupt.Frame1(5).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_05", "")
    frmHaupt.Frame1(6).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_06", "")
    frmHaupt.Frame1(7).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_07", "")
    frmHaupt.Frame1(8).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_08", "")
    frmHaupt.Frame1(9).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_09", "")
    frmHaupt.Frame1(10).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_10", "")
    frmHaupt.Frame1(11).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_11", "")
    frmHaupt.Frame1(12).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_12", "")
    frmHaupt.Frame1(13).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_13", "")
    frmHaupt.Frame1(14).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_14", "")
    frmHaupt.Frame1(15).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_15", "")
    frmHaupt.Frame1(16).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_16", "")
    frmHaupt.Frame1(17).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_17", "")
    frmHaupt.Frame1(18).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_18", "")
    frmHaupt.Frame1(19).Caption = GetINISetting(AppPathGet & fName, "Frames", "LBL_FRAME_19", "")
' ToolTips
    frmHaupt.Frame1(0).ToolTipText = GetINISetting(AppPathGet & fName, "ToolTip", "TT_FRAME_00", "")
    frmHaupt.Frame1(5).ToolTipText = GetINISetting(AppPathGet & fName, "ToolTip", "TT_FRAME_05", "")
    frmHaupt.Frame1(11).ToolTipText = GetINISetting(AppPathGet & fName, "ToolTip", "TT_FRAME_11", "")
    frmHaupt.Frame1(15).ToolTipText = GetINISetting(AppPathGet & fName, "ToolTip", "TT_FRAME_15", "")
    frmHaupt.Frame1(18).ToolTipText = GetINISetting(AppPathGet & fName, "ToolTip", "TT_FRAME_18", "")
End Sub

' Sprachdatei schreiben
Public Sub writeFile()
    lblSplashCaption = frmLanguage.Text2
    lblFormCaption = " OldMan " & lblSplashCaption
    SaveINISetting AppPathGet & fName, "Translation", "Many thanks to translator ", lblFormCaption & " for it's work" & vbCrLf
    lblFormCaption = frmLanguage.Text1(1) & "  DL7AHW"
    SaveINISetting AppPathGet & fName, "Form", "LBL_FORM", lblFormCaption
    SaveINISetting AppPathGet & fName, "Form", "LBL_CAPACITIES", frmLanguage.Text1(2)
    SaveINISetting AppPathGet & fName, "Form", "LBL_CAN_RADIATOR", frmLanguage.Text1(3)
    SaveINISetting AppPathGet & fName, "Form", "LBL_TUBE_RADIATOR", frmLanguage.Text1(4)
    SaveINISetting AppPathGet & fName, "Form", "LBL_BALL_RADIATOR", frmLanguage.Text1(5)
    SaveINISetting AppPathGet & fName, "Form", "LBL_BOX_RADIATOR", frmLanguage.Text1(6)
    SaveINISetting AppPathGet & fName, "Form", "LBL_AREA_RADIATOR", frmLanguage.Text1(7) & vbCrLf
    SaveINISetting AppPathGet & fName, "Buttons", "LBL_BUT_CALC", frmLanguage.Text1(9)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_PROGRAM", frmLanguage.Text1(11)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_QUIT", frmLanguage.Text1(12)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_ANTENNA", frmLanguage.Text1(13)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_CAPACITIES", frmLanguage.Text1(14)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_KAP_RADIATOR", frmLanguage.Text1(15)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_CAN", frmLanguage.Text1(16)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_TUBE", frmLanguage.Text1(17)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_BALL", frmLanguage.Text1(18)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_BOX", frmLanguage.Text1(19)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_AREA", frmLanguage.Text1(20)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_HELP", frmLanguage.Text1(21)
    SaveINISetting AppPathGet & fName, "Menu", "MNU_ABOUT", frmLanguage.Text1(22) & vbCrLf
    SaveINISetting AppPathGet & fName, "SplashScreen", "LBL_SPLASH_0", frmLanguage.Text1(23)
    SaveINISetting AppPathGet & fName, "SplashScreen", "LBL_SPLASH_1", frmLanguage.Text1(24)
    SaveINISetting AppPathGet & fName, "SplashScreen", "LBL_SPLASH_2", frmLanguage.Text1(25)
    SaveINISetting AppPathGet & fName, "SplashScreen", "LBL_SPLASH_3", frmLanguage.Text2 & vbCrLf
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_00", frmLanguage.Text1(26)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_01", frmLanguage.Text1(27)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_02", frmLanguage.Text1(28)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_03", frmLanguage.Text1(29)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_04", frmLanguage.Text1(30)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_05", frmLanguage.Text1(31)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_06", frmLanguage.Text1(32)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_07", frmLanguage.Text1(33)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_08", frmLanguage.Text1(34)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_09", frmLanguage.Text1(35)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_10", frmLanguage.Text1(36)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_11", frmLanguage.Text1(37)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_12", frmLanguage.Text1(38)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_13", frmLanguage.Text1(39)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_14", frmLanguage.Text1(40)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_15", frmLanguage.Text1(41)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_16", frmLanguage.Text1(42)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_17", frmLanguage.Text1(43)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_18", frmLanguage.Text1(44)
    SaveINISetting AppPathGet & fName, "Frames", "LBL_FRAME_19", frmLanguage.Text1(45) & vbCrLf
    SaveINISetting AppPathGet & fName, "ToolTip", "TT_FRAME_00", frmLanguage.Text1(46)
    SaveINISetting AppPathGet & fName, "ToolTip", "TT_FRAME_05", frmLanguage.Text1(47)
    SaveINISetting AppPathGet & fName, "ToolTip", "TT_FRAME_11", frmLanguage.Text1(48)
    SaveINISetting AppPathGet & fName, "ToolTip", "TT_FRAME_15", frmLanguage.Text1(49)
    SaveINISetting AppPathGet & fName, "ToolTip", "TT_FRAME_18", frmLanguage.Text1(50)
End Sub
